preGenMap = require 'data.preGenMap'

function mapGen(w,h,p,gs,t,ts,preGen, mapN)

	-- Scramble tombolla
	math.randomseed(os.time())

	if not w then w = 15 end
	if not h then h = 15 end
	if not g then g = 1 end
	if not gs then gs = 1 end

	t.gs = gs -- Map graphics set
	t.ts = ts or 64

	local SP = {	-- Spawn coordinates
					{1,1,taken = false},
					{math.floor((w)/2),1,taken = false},
					{w-1,1,taken = false},
					{w-1,math.floor((h)/2),taken = false},
					{1,math.floor((h)/2),taken = false},
					{w-1,h-1,taken = false},
					{math.floor((w)/2),h-1,taken = false},
					{1, h-1,taken = false},
					{1,math.floor((h)/2),taken = false},

				}

	if preGen then -- Randomly generated map

		for y = 0,h do

			for x = 0,w do

				local list =
								{
								{"floor", "Indstrctbl", "wall", "bound", "spawn"},
								{false, false, true, false},
								}

				if preGenMap[p][mapN][y][x] == 0 then

					local n = 1

					if math.random(0,100) <= 90 then
					n = 3
					end

				t[#t+1] = {x = (x)*ts,y = (y)*ts, tile = "floor", destroy = list[2][preGenMap[p][mapN][y][x]], g = n, gs = gs, mType = list[1][preGenMap[p][mapN][y][x]]}

				else

					t[#t+1] = {x = (x)*ts,y = (y)*ts, tile = "floor", destroy = list[2][preGenMap[p][mapN][y][x]], g = preGenMap[p][mapN][y][x], gs = gs, mType = list[1][preGenMap[p][mapN][y][x]]}

					if preGenMap[p][mapN][y][x] == 5 then -- Make player spawn-point
						t[#t].g = 1
					end

				end

			end

		end

	else

		local xPlace = true -- Decide where to place indestructables
		local yPlace = true -- || --
		local players = 0

		for y = 0, h do

			for x = 0, w do

				-- Make outer bounds

				if y == 0 then
					t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 4, gs = gs, mType = "bound"}
				end

				if y == h then
					t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 4, gs = gs, mType = "bound"}
				end

				if x == 0 then
					t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 4, gs = gs, mType = "bound"}
				end

				if x == w then
					t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 4, gs = gs, mType = "bound"}
				end

				-- Make player spawn-point

				for i = 1, #SP do

					if x == SP[i][1] and y == SP[i][2] and players < p then

						print("Player spawn-point", i)
						t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 1, gs = gs, mType = "spawn"}
						players = players + 1

						-- Make bomb room

						for n = 1,4 do

							local list =
										{
											{x+1,y},
											{x,y+1},
											{x-1,y},
											{x,y-1},
										}

							local found = false
							for i,v in ipairs(t) do

								if v.x == list[n][1]*ts and v.y == list[n][2]*ts and v.mType == "bound" then

									found = true

								end

							end

							if not found then

								t[#t+1] = {x = list[n][1]*ts,y = list[n][2]*ts, destroy = false, g = 1, gs = gs, mType = "floor"}

							end

						end

					end

				end

				-- Make indestructables

				if x > 1 and y > 1 then

					if yPlace and xPlace and x < w and y < h then
						t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 2, gs = gs, mType = "Indstrctbl"}
					end

				end

				xPlace = not xPlace

			end

			yPlace = not yPlace

		end

		-- Make floor

		for y = 0, h do

			for x = 0, w do

				local found = false
				for i,v in ipairs(t) do

					if v.x == x*ts and v.y == y*ts then

						found = true

					end

				end

				if not found then

					if math.random(0,100) < 20 then
					t[#t+1] = {x = x*ts,y = y*ts, destroy = false, g = 1, gs = gs, mType = "floor"}
					else
					t[#t+1] = {x = x*ts,y = y*ts, destroy = true, g = 3, gs = gs, mType = "wall"}
					end

				end

			end

		end

	end

end

return mapGen

