-- Love.load

	function love.load(arg)

			-- Libraries

		local bump = require 'libs.bump'

			-- Data
		local map = require 'data.map'
		local player = require 'data.player'
		local bomb = require 'data.bomb'

			-- Graphics

		local graphics = require 'data.graphics.graphics'

			-- Functions

		local walk = require 'data.functions.walk'
		local lay = require 'data.functions.lay'
		local col = require 'data.functions.col'
		local freshBomb = require 'data.functions.freshBomb'
		local mapGen = require 'data.functions.mapGen'
		local animatePlayer = require 'data.functions.animatePlayer'
		local animateBomb = require 'data.functions.animateBomb'
			-- Pregeneration

		mapGen(14,14,4,1,map,64,false,2) -- (width, height, number-of-players, map-graphics-set, table, map-tile-size,preGen)

			-- Setting up player spawn-points.
		local n = 1
		for i, tile in ipairs(map) do

			if tile.mType == "spawn" then

				player[n].x = tile.x
				player[n].y = tile.y

				if n < #player then
					n = n + 1
				end

			end

		end

			-- Setting up Bump.lua

		map.world = bump.newWorld(64)

				-- Add map-tiles
		for i, tile in ipairs(map) do
			if tile.g ~= 1 then
				map.world:add(tile, tile.x,tile.y,map.ts,map.ts)
			end
		end
				-- Add players
		for i, p in ipairs(player) do
			map.world:add(p, p.x, p.y, p.w, p.h)
		end

	end

-- Love.keypressed

local key = require 'data.functions.key'

-- Love.update

	function love.update(dt)

		for i, p in ipairs(player) do -- Player

			-- Checking if player walk key pressed
			walk(p, dt)

			-- Checking key pressed
				-- Bomb key pressed,
			love.keypressed()

			-- Collision
				-- Player
			local newX, newY, cols, len = map.world:move(p, p.x, p.y)
			p.x, p.y = newX, newY
				-- bomb
			freshBomb(bomb, player, map) -- Walk off fresh bombs

			-- Animation
				-- Player
			animatePlayer(player, 3, 3, dt)
				-- Bomb
			animateBomb(bomb, #graphics.bomb[2], dt)
		end



	end

-- Love.draw

	function love.draw(dt)

		for i, tile in ipairs(map) do -- Draw map

			love.graphics.draw(graphics.map[tile.gs][tile.g], tile.x, tile.y)

		end

		for i, bmb in ipairs(bomb) do -- Draw bombs

			love.graphics.draw(graphics.bomb[bmb.mode][bmb.anim], bmb.x+bmb.w/2, bmb.y+bmb.h/2, bmb.angle, 1,1, bmb.w/2, bmb.h/2)

		end

		for i, p in ipairs(player) do -- Draw player

			love.graphics.draw(graphics.player[p.graphics][p.direction][p.anim], p.x, p.y)

		end

	end


